aboutsummaryrefslogtreecommitdiff
path: root/libexec/rc
diff options
context:
space:
mode:
Diffstat (limited to 'libexec/rc')
-rwxr-xr-xlibexec/rc/rc.d/accounting29
1 files changed, 18 insertions, 11 deletions
diff --git a/libexec/rc/rc.d/accounting b/libexec/rc/rc.d/accounting
index 0c7ac36c0e81..dd33c2f1f07b 100755
--- a/libexec/rc/rc.d/accounting
+++ b/libexec/rc/rc.d/accounting
@@ -21,23 +21,27 @@ start_cmd="accounting_start"
stop_cmd="accounting_stop"
rotate_log_cmd="accounting_rotate_log"
+create_accounting_file()
+{
+ install -o root -g wheel -m 0640 /dev/null "${accounting_file}"
+}
+
accounting_start()
{
local _dir
_dir="${accounting_file%/*}"
if [ ! -d "$_dir" ]; then
- if ! mkdir -p "$_dir"; then
+ if ! mkdir -p -m 0750 "$_dir"; then
err 1 "Could not create $_dir."
fi
fi
if [ ! -e "$accounting_file" ]; then
echo -n "Creating accounting file ${accounting_file}"
- touch "$accounting_file"
+ create_accounting_file
echo '.'
fi
- chmod 644 "$accounting_file"
echo "Turning on accounting."
${accounting_command} ${accounting_file}
@@ -51,21 +55,24 @@ accounting_stop()
accounting_rotate_log()
{
- local _dir _file
+ # Note that this function must handle being called as "onerotate_log"
+ # (by the periodic scripts) when accounting is disabled, and handle
+ # being called multiple times (by an admin making mistakes) without
+ # anything having actually rotated the old .0 file out of the way.
- _dir="${accounting_file%/*}"
- cd $_dir
+ if [ -e "${accounting_file}.0" ]; then
+ err 1 "Cannot rotate accounting log, ${accounting_file}.0 already exists."
+ fi
- if checkyesno accounting_enable; then
- _file=`mktemp newacct-XXXXX`
- chmod 644 $_file
- ${accounting_command} ${_dir}/${_file}
+ if [ ! -e "${accounting_file}" ]; then
+ err 1 "Cannot rotate accounting log, ${accounting_file} does not exist."
fi
mv ${accounting_file} ${accounting_file}.0
if checkyesno accounting_enable; then
- mv $_file ${accounting_file}
+ create_accounting_file
+ ${accounting_command} "${accounting_file}"
fi
}